Bug 971515 - [abrt] xscreensaver-base-5.21-7.fc19: Process /usr/bin/xscreensaver was killed by signal 11 (SIGSEGV)
[abrt] xscreensaver-base-5.21-7.fc19: Process /usr/bin/xscreensaver was kille...
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: xscreensaver (Show other bugs)
19
x86_64 Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Mamoru TASAKA
Fedora Extras Quality Assurance
abrt_hash:bffd09ba4344e78811bdf72196b...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-06 13:05 EDT by Terry Polzin
Modified: 2015-02-17 10:28 EST (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-17 10:28:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
File: backtrace (17.22 KB, text/plain)
2013-06-06 13:05 EDT, Terry Polzin
no flags Details
File: cgroup (144 bytes, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: core_backtrace (2.44 KB, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: dso_list (3.63 KB, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: environ (1.56 KB, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: limits (1.29 KB, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: maps (17.30 KB, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: open_fds (402 bytes, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: proc_pid_status (1.80 KB, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details
File: var_log_messages (240 bytes, text/plain)
2013-06-06 13:06 EDT, Terry Polzin
no flags Details

  None (edit)
Description Terry Polzin 2013-06-06 13:05:56 EDT
Version-Release number of selected component:
xscreensaver-base-5.21-7.fc19

Additional info:
reporter:       libreport-2.1.4
backtrace_rating: 4
cmdline:        xscreensaver -no-splash
executable:     /usr/bin/xscreensaver
kernel:         3.9.4-301.fc19.x86_64
runlevel:       N 5
uid:            16777216
xsession_errors: 

Truncated backtrace:
Thread no. 1 (10 frames)
 #2 spt_init at setproctitle.c:152
 #3 call_init at dl-init.c:82
 #4 _dl_init at dl-init.c:131
 #5 dl_open_worker at dl-open.c:566
 #6 _dl_catch_error at dl-error.c:177
 #7 _dl_open at dl-open.c:656
 #8 dlopen_doit at dlopen.c:66
 #9 _dl_catch_error at dl-error.c:177
 #10 _dlerror_run at dlerror.c:163
 #11 __dlopen at dlopen.c:87
Comment 1 Terry Polzin 2013-06-06 13:05:59 EDT
Created attachment 757759 [details]
File: backtrace
Comment 2 Terry Polzin 2013-06-06 13:06:02 EDT
Created attachment 757760 [details]
File: cgroup
Comment 3 Terry Polzin 2013-06-06 13:06:05 EDT
Created attachment 757761 [details]
File: core_backtrace
Comment 4 Terry Polzin 2013-06-06 13:06:08 EDT
Created attachment 757762 [details]
File: dso_list
Comment 5 Terry Polzin 2013-06-06 13:06:11 EDT
Created attachment 757763 [details]
File: environ
Comment 6 Terry Polzin 2013-06-06 13:06:14 EDT
Created attachment 757764 [details]
File: limits
Comment 7 Terry Polzin 2013-06-06 13:06:18 EDT
Created attachment 757765 [details]
File: maps
Comment 8 Terry Polzin 2013-06-06 13:06:21 EDT
Created attachment 757767 [details]
File: open_fds
Comment 9 Terry Polzin 2013-06-06 13:06:25 EDT
Created attachment 757769 [details]
File: proc_pid_status
Comment 10 Terry Polzin 2013-06-06 13:06:28 EDT
Created attachment 757770 [details]
File: var_log_messages
Comment 11 Mamoru TASAKA 2013-06-06 18:06:56 EDT
Looks like pam library is calling dlopen() and segv happens there.
Once switching to glibc.
Comment 12 Siddhesh Poyarekar 2013-06-07 06:47:18 EDT
The segv is in libbsd, not in glibc:

#2  spt_init (argc=2, argv=0x7fff22d1fb98, envp=0x0) at setproctitle.c:152
        base = 0x7fff22d2099c "xscreensaver"
        end = 0x7fff22d209a9 "-no-splash"
        nul = 0x7fff22d209a8 ""
        tmp = <optimized out>
        i = 0

Is the environment expected to be NULL?  If it is, then it's a bug in libbsd, or else it would be nice to have a reproducer that replicates this behaviour.
Comment 13 Mamoru TASAKA 2013-06-13 02:09:52 EDT
(In reply to Siddhesh Poyarekar from comment #12)
> Is the environment expected to be NULL?

At least clearenv() seems to set environ to NULL (I don't know if pam authentification calls clearenv()). Terry, would you attach /etc/pam.d/xscreensaver and /etc/pam.d/system-auth ?
Comment 14 Terry Polzin 2013-06-13 13:54:33 EDT
cat xscreensaver 
#%PAM-1.0

# Fedora Core 5:
auth       include	system-auth

# SuSE 9.0: (along with "configure --with-passwd-helper" and "unix2_chkpwd")
# auth     required       pam_unix2.so	nullok

# Distant past:
# auth       required	/lib/security/pam_pwdb.so shadow nullok

# Account validation
account include system-auth

[OLYMPIC\tpolzin@linuxadmin pam.d]$ cat system-auth
#%PAM-1.0
# This file is auto-generated.
# User changes will be destroyed the next time authconfig is run.
auth        required      pam_env.so
auth        sufficient    pam_unix.so nullok try_first_pass
auth        requisite     pam_succeed_if.so uid >= 1000 quiet_success
auth        sufficient    pam_winbind.so use_first_pass
auth        required      pam_deny.so

account     required      pam_access.so
account     required      pam_unix.so broken_shadow
account     sufficient    pam_localuser.so
account     sufficient    pam_succeed_if.so uid < 1000 quiet
account     [default=bad success=ok user_unknown=ignore] pam_winbind.so
account     required      pam_permit.so

password    requisite     pam_pwquality.so try_first_pass retry=3 type=
password    sufficient    pam_unix.so sha512 shadow nullok try_first_pass use_authtok
password    sufficient    pam_winbind.so use_authtok
password    required      pam_deny.so

session     optional      pam_keyinit.so revoke
session     required      pam_limits.so
-session     optional      pam_systemd.so
session     optional      pam_mkhomedir.so
session     [success=1 default=ignore] pam_succeed_if.so service in crond quiet use_uid
session     required      pam_unix.so
session     optional      pam_winbind.so

ls -l system-auth
lrwxrwxrwx. 1 root root 14 Mar  8 11:49 system-auth -> system-auth-ac
Comment 15 Fedora End Of Life 2015-01-09 13:20:51 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 16 Carlos O'Donell 2015-01-09 14:53:40 EST
The first problem is that setproctitle_init must never be called from dlopen, it was moved (in possibly later versions I think) into a static stub that has to be linked against he application instead. The reason being that you can't manipulate the environ in an MT-safe fashion once the application has started, so you link against a stub that runs setproctitle_init as an application constructor.

Secondly, the envp should not be null. If the application manipulated envp to be null, then it breaks the expectations of setproctitle_init, and should be fixed and is probably related to the late initialization of libbsd.

Assigning back to xscreensaver for analysis.
Comment 17 Fedora End Of Life 2015-02-17 10:28:52 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.